import { useCallback } from 'react';
import { useClient } from './use-client';

var useStaticResolver = function useStaticResolver() {
  var client = useClient();
  return useCallback(function (assetPath) {
    if (typeof assetPath === 'string') {
      return client.getStaticAssetUrl(assetPath);
    } else {
      return assetPath.map(function (path) {
        return client.getStaticAssetUrl(path);
      });
    }
  }, [client]);
};

export { useStaticResolver };
//# sourceMappingURL=use-static-resolver.js.map