"use strict";

exports.__esModule = true;
exports.useCommand = useCommand;

var _react = require("react");

var _generic = require("./generic");

var _useClient = require("./use-client");

var _resolveCore = require("resolve-core");

function useCommand(command, options, callback, dependencies) {
  var client = (0, _useClient.useClient)();
  var actualOptions = (0, _resolveCore.firstOfType)(_generic.isOptions, options);
  var actualCallback = (0, _resolveCore.firstOfType)(_generic.isCallback, options, callback);
  var actualDependencies = (0, _resolveCore.firstOfType)(_generic.isDependencies, options, callback, dependencies);

  if (typeof command === 'function') {
    if ((0, _generic.isDependencies)(actualDependencies)) {
      return (0, _react.useCallback)(function () {
        return client.command(command.apply(void 0, arguments), actualOptions, actualCallback);
      }, [client].concat(actualDependencies));
    }

    return function () {
      return client.command(command.apply(void 0, arguments), actualOptions, actualCallback);
    };
  }

  if ((0, _generic.isDependencies)(actualDependencies)) {
    return (0, _react.useCallback)(function () {
      return client.command(command, actualOptions, actualCallback);
    }, [client].concat(actualDependencies));
  }

  return function () {
    return client.command(command, actualOptions, actualCallback);
  };
}
//# sourceMappingURL=use-command.js.map