import { Command, CommandResult, CommandOptions, CommandCallback } from 'resolve-client';
import { HookExecutor } from './generic';
export declare type CommandBuilder<TArgs extends any[], TCmd extends Command> = (...data: TArgs) => TCmd;
export declare type CommandExecutor<TArgs extends any[]> = HookExecutor<TArgs, CommandResult>;
declare function useCommand<TCmd extends Command>(command: TCmd): CommandExecutor<void[]>;
declare function useCommand<TCmd extends Command>(command: TCmd, options: CommandOptions): CommandExecutor<void[]>;
declare function useCommand<TCmd extends Command>(command: TCmd, callback: CommandCallback<TCmd>): CommandExecutor<void[]>;
declare function useCommand<TCmd extends Command>(command: TCmd, dependencies: any[]): CommandExecutor<void[]>;
declare function useCommand<TCmd extends Command>(command: TCmd, callback: CommandCallback<TCmd>, dependencies: any[]): CommandExecutor<void[]>;
declare function useCommand<TCmd extends Command>(command: TCmd, options: CommandOptions, callback: CommandCallback<TCmd>): CommandExecutor<void[]>;
declare function useCommand<TCmd extends Command>(command: TCmd, options: CommandOptions, dependencies: any[]): CommandExecutor<void[]>;
declare function useCommand<TCmd extends Command>(command: TCmd, options: CommandOptions, callback: CommandCallback<TCmd>, dependencies: any[]): CommandExecutor<void[]>;
declare function useCommand<TArgs extends any[], TCmd extends Command>(builder: CommandBuilder<TArgs, TCmd>): CommandExecutor<TArgs>;
declare function useCommand<TArgs extends any[], TCmd extends Command>(builder: CommandBuilder<TArgs, TCmd>, options: CommandOptions): CommandExecutor<TArgs>;
declare function useCommand<TArgs extends any[], TCmd extends Command>(builder: CommandBuilder<TArgs, TCmd>, callback: CommandCallback<TCmd>): CommandExecutor<TArgs>;
declare function useCommand<TArgs extends any[], TCmd extends Command>(builder: CommandBuilder<TArgs, TCmd>, dependencies: any[]): CommandExecutor<TArgs>;
declare function useCommand<TArgs extends any[], TCmd extends Command>(builder: CommandBuilder<TArgs, TCmd>, callback: CommandCallback<TCmd>, dependencies: any[]): CommandExecutor<TArgs>;
declare function useCommand<TArgs extends any[], TCmd extends Command>(builder: CommandBuilder<TArgs, TCmd>, options: CommandOptions, callback: CommandCallback<TCmd>): CommandExecutor<TArgs>;
declare function useCommand<TArgs extends any[], TCmd extends Command>(builder: CommandBuilder<TArgs, TCmd>, options: CommandOptions, dependencies: any[]): CommandExecutor<TArgs>;
declare function useCommand<TArgs extends any[], TCmd extends Command>(builder: CommandBuilder<TArgs, TCmd>, options: CommandOptions, callback: CommandCallback<TCmd>, dependencies: any[]): CommandExecutor<TArgs>;
export { useCommand };
