import { Query, QueryOptions, QueryResult, QueryCallback } from 'resolve-client';
import { HookExecutor } from './generic';
export declare type QueryBuilder<TArgs extends any[], TQuery extends Query> = (...data: TArgs) => TQuery;
export declare type QueryExecutor<TArgs extends any[]> = HookExecutor<TArgs, QueryResult>;
declare function useQuery<TQuery extends Query>(query: Query): QueryExecutor<void[]>;
declare function useQuery<TQuery extends Query>(query: TQuery, options: QueryOptions): QueryExecutor<void[]>;
declare function useQuery<TQuery extends Query>(query: TQuery, callback: QueryCallback<TQuery>): QueryExecutor<void[]>;
declare function useQuery<TQuery extends Query>(query: TQuery, dependencies: any[]): QueryExecutor<void[]>;
declare function useQuery<TQuery extends Query>(query: Query, callback: QueryCallback<TQuery>, dependencies: any[]): QueryExecutor<void[]>;
declare function useQuery<TQuery extends Query>(query: TQuery, options: QueryOptions, callback: QueryCallback<TQuery>): QueryExecutor<void[]>;
declare function useQuery<TQuery extends Query>(query: Query, options: QueryOptions, dependencies: any[]): QueryExecutor<void[]>;
declare function useQuery<TQuery extends Query>(query: Query, options: QueryOptions, callback: QueryCallback<TQuery>, dependencies: any[]): QueryExecutor<void[]>;
declare function useQuery<TArgs extends any[], TQuery extends Query>(builder: QueryBuilder<TArgs, TQuery>): QueryExecutor<TArgs>;
declare function useQuery<TArgs extends any[], TQuery extends Query>(builder: QueryBuilder<TArgs, TQuery>, options: QueryOptions): QueryExecutor<TArgs>;
declare function useQuery<TArgs extends any[], TQuery extends Query>(builder: QueryBuilder<TArgs, TQuery>, callback: QueryCallback<TQuery>): QueryExecutor<TArgs>;
declare function useQuery<TArgs extends any[], TQuery extends Query>(builder: QueryBuilder<TArgs, TQuery>, dependencies: any[]): QueryExecutor<TArgs>;
declare function useQuery<TArgs extends any[], TQuery extends Query>(builder: QueryBuilder<TArgs, TQuery>, callback: QueryCallback<TQuery>, dependencies: any[]): QueryExecutor<TArgs>;
declare function useQuery<TArgs extends any[], TQuery extends Query>(builder: QueryBuilder<TArgs, TQuery>, options: QueryOptions, callback: QueryCallback<TQuery>): QueryExecutor<TArgs>;
declare function useQuery<TArgs extends any[], TQuery extends Query>(builder: QueryBuilder<TArgs, TQuery>, options: QueryOptions, dependencies: any[]): QueryExecutor<TArgs>;
declare function useQuery<TArgs extends any[], TQuery extends Query>(builder: QueryBuilder<TArgs, TQuery>, options: QueryOptions, callback: QueryCallback<TQuery>, dependencies: any[]): QueryExecutor<TArgs>;
export { useQuery };
