import { Event, SerializableMap } from 'resolve-core';
import { QueryOptions, SubscribeCallback, Subscription } from 'resolve-client';
declare type StateChangedCallback = (state: any, initial: boolean) => void;
declare type EventReceivedCallback = (event: Event) => void;
declare type PromiseOrVoid<T> = Promise<T> | void;
declare type ViewModelConnection = {
    connect: (done?: SubscribeCallback) => PromiseOrVoid<Subscription>;
    dispose: (done?: (error?: Error) => void) => PromiseOrVoid<void>;
    initialState: any;
};
declare function useViewModel(modelName: string, aggregateIds: string[] | '*', stateChangeCallback: StateChangedCallback): ViewModelConnection;
declare function useViewModel(modelName: string, aggregateIds: string[] | '*', args: SerializableMap, stateChangeCallback: StateChangedCallback): ViewModelConnection;
declare function useViewModel(modelName: string, aggregateIds: string[] | '*', args: SerializableMap, stateChangeCallback: StateChangedCallback, eventReceivedCallback: EventReceivedCallback): ViewModelConnection;
declare function useViewModel(modelName: string, aggregateIds: string[] | '*', stateChangeCallback: StateChangedCallback, eventReceivedCallback: EventReceivedCallback): ViewModelConnection;
declare function useViewModel(modelName: string, aggregateIds: string[] | '*', args: SerializableMap, stateChangeCallback: StateChangedCallback, queryOptions: QueryOptions): ViewModelConnection;
declare function useViewModel(modelName: string, aggregateIds: string[] | '*', stateChangeCallback: StateChangedCallback, queryOptions: QueryOptions): ViewModelConnection;
declare function useViewModel(modelName: string, aggregateIds: string[] | '*', args: SerializableMap, stateChangeCallback: StateChangedCallback, eventReceivedCallback: EventReceivedCallback, queryOptions: QueryOptions): ViewModelConnection;
declare function useViewModel(modelName: string, aggregateIds: string[] | '*', stateChangeCallback: StateChangedCallback, eventReceivedCallback: EventReceivedCallback, queryOptions: QueryOptions): ViewModelConnection;
declare function useViewModel(modelName: string, aggregateIds: string[] | '*', args: SerializableMap, stateChangeCallback: StateChangedCallback, eventReceivedCallback: EventReceivedCallback, queryOptions: QueryOptions): ViewModelConnection;
export { useViewModel };
