import { Command, CommandCallback, CommandOptions, CommandResult } from 'resolve-client';
import { HookExecutor } from './generic';
export declare type CommandBuilder<T> = (data: T) => Command;
declare type CommandExecutor<T> = HookExecutor<T, CommandResult>;
declare function useCommandBuilder<T>(builder: CommandBuilder<T>): CommandExecutor<T>;
declare function useCommandBuilder<T>(builder: CommandBuilder<T>, options: CommandOptions): CommandExecutor<T>;
declare function useCommandBuilder<T>(builder: CommandBuilder<T>, callback: CommandCallback): CommandExecutor<T>;
declare function useCommandBuilder<T>(builder: CommandBuilder<T>, dependencies: any[]): CommandExecutor<T>;
declare function useCommandBuilder<T>(builder: CommandBuilder<T>, callback: CommandCallback, dependencies: any[]): CommandExecutor<T>;
declare function useCommandBuilder<T>(builder: CommandBuilder<T>, options: CommandOptions, callback: CommandCallback): CommandExecutor<T>;
declare function useCommandBuilder<T>(builder: CommandBuilder<T>, options: CommandOptions, dependencies: any[]): CommandExecutor<T>;
declare function useCommandBuilder<T>(builder: CommandBuilder<T>, options: CommandOptions, callback: CommandCallback, dependencies: any[]): CommandExecutor<T>;
export { useCommandBuilder };
