import { Query, QueryOptions, QueryResult, QueryCallback } from 'resolve-client';
import { HookExecutor } from './generic';
declare type QueryBuilder<T> = (data: T) => Query;
declare type QueryExecutor<T> = HookExecutor<T, QueryResult>;
declare function useQueryBuilder<T>(builder: QueryBuilder<T>): QueryExecutor<T>;
declare function useQueryBuilder<T>(builder: QueryBuilder<T>, options: QueryOptions): QueryExecutor<T>;
declare function useQueryBuilder<T>(builder: QueryBuilder<T>, callback: QueryCallback): QueryExecutor<T>;
declare function useQueryBuilder<T>(builder: QueryBuilder<T>, dependencies: any[]): QueryExecutor<T>;
declare function useQueryBuilder<T>(builder: QueryBuilder<T>, callback: QueryCallback, dependencies: any[]): QueryExecutor<T>;
declare function useQueryBuilder<T>(builder: QueryBuilder<T>, options: QueryOptions, callback: QueryCallback): QueryExecutor<T>;
declare function useQueryBuilder<T>(builder: QueryBuilder<T>, options: QueryOptions, dependencies: any[]): QueryExecutor<T>;
declare function useQueryBuilder<T>(builder: QueryBuilder<T>, options: QueryOptions, callback: QueryCallback, dependencies: any[]): QueryExecutor<T>;
export { useQueryBuilder };
