import { QueryOptions, SubscribeCallback, Subscription } from 'resolve-client';
declare type StateChangedCallback = (state: any) => void;
declare type PromiseOrVoid<T> = Promise<T> | void;
declare type ViewModelConnection = {
    connect: (done?: SubscribeCallback) => PromiseOrVoid<Subscription>;
    dispose: (done?: (error?: Error) => void) => PromiseOrVoid<void>;
};
declare const useViewModel: (modelName: string, aggregateIds: string[] | "*", stateChangeCallback: StateChangedCallback, queryOptions?: QueryOptions | undefined) => ViewModelConnection;
export { useViewModel };
